#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    int sum=0;
    vector<int> c(n);

    for(int i=0; i<n; i++)
    {
        cin >> c[i];
        sum+=c[i];
    }
    int x=0, y=0, z=0, s1=0;
    for(int i=0; i<n; i++)
    {
        if(s1<sum/3)
        {
            s1+=c[y];
            y++;
        }
        else if(s1>sum/3)
        {
            s1-=c[x];
            x++;
        }
        else
        {
            break;
        }
    }
    s1=c[y];
    z=y+1;
    for(int i=0; i<n;i++)
    {
        if(s1==sum/3)
        {
            break;
        }
        else
        {
            s1+=c[z];
            z++;
            if(z>=n)
            {
                z=0;
            }
        }
    }
    vector<int> a({x, y, z});
    sort(a.begin(), a.end());
    cout << ((sum%3==0)==false) << "\n";
    cout<< a[0]+1 << " " << a[1]+1 << " " << a[2]+1;
}